/**
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Jianfeng Gao ( jianfeng dot gao at kit dot edu )
 * @date       2023
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <type_traits>
#include <armarx/control/common/aron_conversions.h>
#include <armarx/control/njoint_mp_controller/task_space/aron/NJointMPControllerConfig.aron.generated.h>


namespace armarx::control::njoint_mp_controller::task_space
{
    struct TSImpedanceMPConfig;
    struct TSAdmittanceMPConfig;
    struct Constraint;
    struct KVILImpedanceMPConfig;

    void fromAron(const arondto::TSImpedanceMPConfig& dto, TSImpedanceMPConfig& bo);
    void fromAron(const arondto::TSAdmittanceMPConfig& dto, TSAdmittanceMPConfig& bo);

    void fromAron(const arondto::Constraint& dto, Constraint& bo);
    Constraint fromAron(const arondto::Constraint& dto);

    void fromAron(const arondto::KVILImpedanceMPConfig& dto, KVILImpedanceMPConfig& bo);
} /// namespace armarx::control::njoint_mp_controller::task_space
