#pragma once

#include <RobotAPI/libraries/skills/provider/SimpleSpecializedSkill.h>

#include <armarx/control/pointing/aron/PointingParams.aron.generated.h>
#include <armarx/control/pointing/core/Pointing.h>

namespace armarx::control::pointing::skills
{
    class Pointing : public armarx::skills::SimpleSpecializedSkill<arondto::PointingParams>
    {
    public:
        using Base = armarx::skills::SimpleSpecializedSkill<arondto::PointingParams>;

        static armarx::skills::SkillDescription GetSkillDescription();

        using Remote = core::Pointing::Remote;
        Pointing(const Remote&);

        MainResult main(const SpecializedMainInput& in) override;

        void onStopRequested() override;
        void onTimeoutReached() override;

    private:
        Remote remote_;
        std::optional<core::Pointing> impl_;
    };

} // namespace armarx::control::pointing::skills
