#include "aron_conversions.h"

namespace armarx::control::pointing
{
    void
    skills::fromAron(const arondto::Side& dto, core::Side& bo)
    {
        switch (dto.value)
        {
            case arondto::Side::Left:
                bo = core::Side::LEFT;
                break;
            case arondto::Side::Right:
                bo = core::Side::RIGHT;
                break;
            default:
                ARMARX_ERROR << "Invalid side";
        }
    }

    void
    skills::fromAron(const arondto::PointingParams& dto, core::Pointing::Parameters& bo)
    {
        fromAron(dto.side, bo.side);
        bo.frame = dto.frame;
        bo.framedTarget = dto.framedTarget;
        bo.handShape = dto.handShape;
        bo.maxVelocity = dto.maxVelocity;
        bo.maxAcceleration = dto.maxAcceleration;
    }

    core::Pointing::Parameters
    skills::fromAron(const arondto::PointingParams& dto)
    {
        core::Pointing::Parameters bo;
        fromAron(dto, bo);
        return bo;
    }

} // namespace armarx::control::pointing
