#pragma once

#include <RobotAPI/libraries/skills/provider/SimpleSpecializedSkill.h>

#include <armarx/control/skills/aron/RelaxHandParams.aron.generated.h>
#include <armarx/control/skills/constants/constants.h>

#include "HandUnitServices.h"

namespace armarx::control::skills::skills
{

    class RelaxHand : public ::armarx::skills::SimpleSpecializedSkill<arondto::RelaxHandParams>
    {

    public:
        static ::armarx::skills::SkillDescription
        GetSkillDescription()
        {
            return ::armarx::skills::SkillDescription{
                .skillId = {.skillName = constants::RELAX_HAND_SKILL_NAME},
                .description = "Relaxes hand joints",
                .timeout = ::armarx::Duration::Seconds(1),
                .parametersType = ParamType::ToAronType()};
        }

        RelaxHand(const HandUnitServices&);

    private:
        ::armarx::skills::Skill::MainResult main(const SpecializedMainInput& in) override;

    private:
        HandUnitServices srv_;
    };

} // namespace armarx::control::skills::skills
